#include <stdio.h>
#include <string.h>
#include "utf8hu.h"

//#define	DEBUG

int iconvgyl(int n, char **in, size_t *b, char **out, size_t *k)
{		// html entitasokra korrigal
int i;
static const char *ikonv[][2] = {
	{ "\xC3\xA3",     "&atilde;" },
	{ "\xE2\x80\x98", "&lsquo;" },
	{ "\xE2\x80\x99", "&rsquo;" },
	{ "\xE2\x80\x93", "&ndash;" },
	{ "\xE2\x80\x94", "&mdash;" },
	{ "\xE2\x80\x9E", "&bdquo;" },
	{ "\xE2\x80\x9D", "&rdquo;" },
	{ "\xE2\x86\x91", "&uarr;" },
	{ "\xE2\x80\xA6", "&hellip;" },
	{ "\xE2\x86\x90", "&larr;" },
	{ "\xE2\x86\x92", "&rarr;" },
	};
#ifdef	DEBUG
unsigned char *mut = (unsigned char *)*in;

fprintf(stderr,"iconvhtm: n=%d, b=%d, k=%d",n,*b,*k);
for(i=0; i<n; i++)
	fprintf(stderr," %02X",*mut++);
fprintf(stderr,"  %.10s\n",*out-10);
#endif
for(i=0; i < sizeof(ikonv)/sizeof(char*)/2; i++)
	{
	int h = strlen(ikonv[i][1]);
	if(n != strlen(ikonv[i][0]) || memcmp(*in,ikonv[i][0],n) != 0 ||
			*k <= h)
		continue;
	memcpy(*out,ikonv[i][1],h);
	*in += n;
	*out += h;
	*b -= n;
	*k -= h;
#ifdef	DEBUG
	fprintf(stderr,"iconvhtm: n=%d, b=%d, k=%d - kesz %.10s\n",n,*b,*k,*out-10);
#endif
	return 1;
	}
return 0;
}
