#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <libgyim.h>
#include "utf8hu.h"

int main(int argc, char *argv[])
{
static const char kapcs[] = "hd:1";
struct flagstr {
	int help:1;	// -h
	int elso:1;	// -1 vagy -d 1
	int szokoz:1;	// az elozo karakter szokoz volt-e
	} flag;
int c,hossz;
unsigned char *mut;
const struct magyarstr *karstr;

flag.help = flag.elso = 0;
while( (c=getopt(argc,argv,kapcs)) >= 0)
	{
	switch(c)
		{
		case '1': flag.elso = 1;
			break;
		case 'h': flag.help = 1;
			break;
		case 'd': if(strcmp(optarg,"1"))
				flag.help = 1;
			else	flag.elso = 1;
			break;
		}
	}

			// Most jon a lenyeg
if(flag.help)
	{
	printf("kisbetu [ -d 1 ] [ filenev ]\n");
	return 1;
	}
mut = (unsigned char *)filemem(optind < argc? argv[optind] : NULL);
flag.szokoz = flag.elso;	// a bemenet elso betuje olyan, mintha szokoz utan jott volna
while(*mut)
	{
	if(flag.elso && isspace(*mut))
		{	// szokoz jott, es figyelni kell
		putchar(*mut++);
		flag.szokoz = 1;
		continue;
		}
	hossz = utf8hukar(mut,&karstr);		// nem szokoz, vagy nem kell figyelni az elso beture
#if	0
	printf("%c  hossz=%d\n",*mut,hossz);
#endif
	if(hossz > 0 && !flag.szokoz)
		{	// kisbetut kell kiirni az eredeti helyett
		if(hossz == 1)
			putchar(karstr->lat2kis);	// lat2 kisbetu
		else	{	// utf8 kisbetu
			putchar(karstr->kicsi[0]);
			putchar(karstr->kicsi[1]);
			}
		}
	else	{	// nem ekezet, vagy szokezdo betu
		putchar(flag.szokoz? *mut: tolower(*mut));	// az elso byte lehet nem magyar nagybetu
		if(hossz == 2) 
			putchar(mut[1]);	// a masodik byte nem lehet nagybetu
		}
	mut += hossz > 0?  hossz: 1;
	flag.szokoz = 0;
	}
return 0;
}
